"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("reflect-metadata");

var _utils = require("./utils");

const registerRoutes = (app, handlerInfos) => {
  handlerInfos.forEach(({
    routePath,
    handler,
    httpMethod
  }) => {
    const routeHandler = (0, _utils.createRouteHandler)(handler);
    const method = httpMethod.toLowerCase();
    const routeMiddlwares = Reflect.getMetadata('middleware', handler) || [];

    if (routeMiddlwares.length > 0) {
      app[method](routePath, routeMiddlwares, routeHandler);
    } else {
      app[method](routePath, routeHandler);
    }
  });
};

var _default = registerRoutes;
exports.default = _default;