import { Operator } from '@modern-js/bff-core';
import { NextFunction } from '@modern-js/types';
import type { Request, Response } from 'express';
export declare type EndFunction = ((func: (res: Response) => void) => void) & ((data: unknown) => void);
declare type MaybeAsync<T> = T | Promise<T>;
declare type PipeFunction<T> = (value: T, end: EndFunction) => MaybeAsync<void> | MaybeAsync<T>;
export declare const Pipe: <T>(func: PipeFunction<T>) => Operator;
export declare type Pipe = typeof Pipe;
export declare const Middleware: (middleware: (req: Request, res: Response, next: NextFunction) => void) => Operator;
export declare type Middleware = typeof Middleware;
export {};